{% import 'macros/c_method_fn.j2' as method_fn %}
{% import 'macros/c_connect_fn.j2' as connect_fn %}
/*
 * Copyright (C) 2022 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#define TLOG_TAG "{{c_impl_name}}_client"

{% if domain == 'trusty_user' %}
#include <assert.h>
#include <lib/tipc/tipc.h>
#include <string.h>
#include <trusty_log.h>
#include <uapi/err.h>
{% elif domain == 'ql_tipc' %}
#include <trusty/sysdeps.h>
#include <trusty/trusty_log.h>
#include <uapi/err.h>
{% endif %}

#include <Bp{{impl_name}}.h>
{% if consts.len(consts.ordered_error_integers) > 0 %}
#include <{{c_impl_name}}.h>
{% else %}
#include <lib/binder/lk_strerror.h>
{% endif %}

{{connect_fn.connect_impl(consts, c_impl_name, impl_name, domain)}}
{{connect_fn.connect_teardown(c_impl_name, impl_name, domain)}}
{% for method in methods %}
{{method_fn.comment(c_impl_name, method)}}
{{method_fn.signature(c_impl_name, method, hdr=false)}} {
{{connect_fn.connect_invoke(c_impl_name, impl_name, domain)}}
{% for arg in method.args %}
{{ method_fn.arg_prolog(iface_name, domain, arg) }}
{%- endfor %}
    rc = {{c_impl_name}}->{{method.name}}(
{% for arg in method.args %}
{{ method_fn.arg_invoke(arg) }} {{ "," if not loop.last else "" }}
{%- endfor %}
    );
    if (rc != android::OK) {
{% if consts.len(consts.ordered_error_integers) > 0 %}
        TLOGE("{{method.name}} failed - %s(%d).\n", {{c_impl_name}}_strerror(rc), rc);
{% else %}
        TLOGE("{{method.name}} failed - %s(%d).\n", lk_strerror(rc), rc);
{% endif %}
        return rc;
    }
{% for arg in method.args %}
{{ method_fn.arg_epilog(arg) }}
{%- endfor %}
    return rc;
}
{{''}}
{{''}}
{%- endfor %}
